uses PocketDrakeSync_Ins;

function InstallWork: String;
var MakroPath : String;
begin

  MakroPath := ReplaceString(Geoget_ScriptFullName, Geoget_ScriptName, '');

  // show ChangeLog
  InsForm_mem_ChangeLog.Lines.Clear;
  if FileExists(MakroPath + 'ChangeLog.txt') then begin
    InsForm_mem_ChangeLog.Lines.Add(FileToString(MakroPath + 'ChangeLog.txt'));
  end;
  InsForm_lbl_PlgVerPrvValue.Caption := GeoGetPackagePreviousVersion(MakroPath + 'PocketDrakeSync.meta.ini');
  InsForm_lbl_PlgVerCurValue.Caption := GeoGetPackageVersion        (MakroPath + 'PocketDrakeSync.meta.ini');
  InsForm.ShowModal;

  // smazne stary ini z duvodu nekompatibility s novymi verzemi (pokud je puvodni verze < 1.3.4b)
  if CompareVer('1.3.4b', GeoGetPackagePreviousVersion(MakroPath + 'PocketDrakeSync.meta.ini')) then  begin 
    if FileExists(MakroPath + 'PocketDrakeSync.ini') then begin
      showmessage(_('A new version of the plugin is not compatible with a previous version. For that reason the settings file PocketDrake.ini will be removed.')+CRLF+CRLF+
                  _('File will be deleted...'));
      DeleteFile(ReplaceString(Geoget_ScriptFullName, Geoget_ScriptName, 'PocketDrakeSync.ini'));
    end; 
  end;
  // prejmenuje stary adrear xTemp na Data (pokud je puvodni verze < 1.5.0)
  if CompareVer('1.5.0', GeoGetPackagePreviousVersion(MakroPath + 'PocketDrakeSync.meta.ini')) then  begin
    if DirectoryExists(MakroPath + 'xTemp') then begin
      CopyTree(MakroPath + 'xTemp', MakroPath + 'Data');
      DelTree (MakroPath + 'xTemp');
    end;
  end;
  // prejmenuje txt soubory registru na reg (pokud je puvodni verze < 1.5.1)
  if CompareVer('1.5.1', GeoGetPackagePreviousVersion(MakroPath + 'PocketDrakeSync.meta.ini')) then  begin 
    if FileExists(MakroPath + 'Data\reg_PDA_Option.txt')  then RenameFile(MakroPath + 'Data\reg_PDA_Option.txt', MakroPath + 'Data\reg_PDA_Option.reg');
    if FileExists(MakroPath + 'Data\reg_PDA_CurrVer.txt') then RenameFile(MakroPath + 'Data\reg_PDA_CurrVer.txt', MakroPath + 'Data\reg_PDA_CurrVer.reg');
    if FileExists(MakroPath + 'Data\reg_PDA_Install.txt') then RenameFile(MakroPath + 'Data\reg_PDA_Install.txt', MakroPath + 'Data\reg_PDA_Install.reg');
  end;
  // prejmenuje reg soubory registru zpet na txt (pokud je puvodni verze < 1.5.2)
  if CompareVer('1.5.2', GeoGetPackagePreviousVersion(MakroPath + 'PocketDrakeSync.meta.ini')) then  begin 
    if FileExists(MakroPath + 'Data\reg_PDA_Option.reg')  then RenameFile(MakroPath + 'Data\reg_PDA_Option.reg', MakroPath + 'Data\reg_PDA_Option.txt');
    if FileExists(MakroPath + 'Data\reg_PDA_CurrVer.reg') then RenameFile(MakroPath + 'Data\reg_PDA_CurrVer.reg', MakroPath + 'Data\reg_PDA_CurrVer.txt');
    if FileExists(MakroPath + 'Data\reg_PDA_Install.reg') then RenameFile(MakroPath + 'Data\reg_PDA_Install.reg', MakroPath + 'Data\reg_PDA_Install.txt');
  end;

  Result :='';  // probehlo bez chyby
end;

function UninstallWork: string;
begin
  Result :='';  // probehlo bez chyby             
end;
