//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi jeden klic do ini souboru}
procedure SaveIniIntValue(Section: String; Key: String; Value: Integer);
var Ini_PD : TIniFile;
begin
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    Ini_PD.WriteInteger(Section, Key, Value);
  finally
    Ini_PD.Free;
  end;
end;
procedure SaveIniStrValue(Section: String; Key: String; Value: String);
var Ini_PD : TIniFile;
begin
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    Ini_PD.WriteString(Section, Key, Value);
  finally
    Ini_PD.Free;
  end;
end;
procedure SaveIniFloatValue(Section: String; Key: String; Value: Single);
var Ini_PD : TIniFile;
begin
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    Ini_PD.WriteFloat(Section, Key, Value);
  finally
    Ini_PD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte jeden klic z ini souboru}
function LoadIniIntValue(Section: String; Key: String; InitValue: Integer): Integer;
var Ini_PD : TIniFile;
begin
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    Result := Ini_PD.ReadInteger(Section, Key, InitValue);
  finally
    Ini_PD.Free;
  end;
end;
function LoadIniStrValue(Section: String; Key: String; InitValue: String): String;
var Ini_PD : TIniFile;
begin
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    Result := Ini_PD.ReadString(Section, Key, InitValue);
  finally
    Ini_PD.Free;
  end;
end;
function LoadIniFloatValue(Section: String; Key: String; InitValue: Single): Single;
var Ini_PD : TIniFile;
begin
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    Result := Ini_PD.ReadFloat(Section, Key, InitValue);
  finally
    Ini_PD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi profil}
procedure SaveProfile(Name: String);
var
  Ini_PD  : TIniFile;
  i       : integer;
  str     : string;
begin
  if (Name <> 'DEFAULT') and (PDSForm_cmb_Profile.ItemIndex = -1) then
    PDSForm_cmb_Profile.Items.Add(Name);
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    with Ini_PD do
    begin
      EraseSection('PROFILES');
      for i:= 0 to PDSForm_cmb_Profile.Items.Count - 1 do begin
        WriteInteger('PROFILES', PDSForm_cmb_Profile.Items[i], i);
        if PDSForm_cmb_Profile.Items[i] = Name then PDSForm_cmb_Profile.ItemIndex := i;
      end;
      WriteBool   (Name, 'ActiveSync'            , PDSForm_rb_ActiveSync            .Checked  );
      WriteBool   (Name, 'CardReader'            , PDSForm_rb_CardReader            .Checked  );
      WriteBool   (Name, 'OffLine'               , PDSForm_rb_Offline               .Checked  );
      WriteBool   (Name, 'db_GG_Full'            , PDSForm_rb_db_GG_Full            .Checked  );
      WriteBool   (Name, 'db_GG_Filter'          , PDSForm_rb_db_GG_Filter          .Checked  );
      WriteBool   (Name, 'db_PD_Default'         , PDSForm_rb_db_PD_Default         .Checked  );
      WriteBool   (Name, 'db_PD_Custom'          , PDSForm_rb_db_PD_Custom          .Checked  );
      WriteString (Name, 'db_PD_CustomName'      , PDSForm_cmb_db_PD_CustomName     .Text     );
      WriteBool   (Name, 'Upd_db_GG'             , PDSForm_cb_Upd_db_GG             .Checked  );
      WriteBool   (Name, 'Gen_FieldNotes_GG'     , PDSForm_cb_Gen_FieldNotes_GG     .Checked  );
      WriteBool   (Name, 'Save_db_PD'            , UpdGGForm_cb_Save_db_PD          .Checked  );
      WriteBool   (Name, 'Gen_FieldNotes_PD'     , UpdGGForm_cb_Gen_FieldNotes_PD   .Checked  );
      WriteBool   (Name, 'Gen_FieldNotes_PD_Auto', UpdGGForm_cb_Gen_FieldNotes_PD_Auto.Checked  );
      WriteBool   (Name, 'Upd_Tracks'            , UpdGGForm_cb_Upd_Tracks          .Checked  );
      WriteBool   (Name, 'Upd_Tracks_Auto'       , UpdGGForm_cb_Upd_Tracks_Auto     .Checked  );
      WriteBool   (Name, 'Upd_Tracks_gpx'        , UpdGGForm_cb_Upd_Tracks_gpx      .Checked  );
      WriteBool   (Name, 'Upd_Tracks_kml'        , UpdGGForm_cb_Upd_Tracks_kml      .Checked  );
      WriteBool   (Name, 'Upd_Tracks_plt'        , UpdGGForm_cb_Upd_Tracks_plt      .Checked  );
      WriteBool   (Name, 'Upd_Tracks_del'        , UpdGGForm_cb_Upd_Tracks_del      .Checked  );
      WriteBool   (Name, 'Del_Tracks'            , UpdGGForm_cb_Del_Tracks          .Checked  );
      WriteBool   (Name, 'PD_Ref_Points'         , UpdPDForm_cb_PD_Ref_points       .Checked  );
      WriteBool   (Name, 'PD_NoteToCmt'          , UpdPDForm_cb_PD_NoteToCmt        .Checked  );
      WriteBool   (Name, 'Upl_FieldNotes'        , PDSForm_cb_Upl_FieldNotes        .Checked  );
      WriteBool   (Name, 'Upl_FieldNotes_GG'     , PDSForm_rb_Upl_FieldNotes_GG     .Checked  );
      WriteBool   (Name, 'Upl_FieldNotes_PD'     , PDSForm_rb_Upl_FieldNotes_PD     .Checked  );
      WriteBool   (Name, 'Upd_db_PD'             , PDSForm_cb_Upd_db_PD             .Checked  );
      WriteBool   (Name, 'Sync_Img'              , PDSForm_cb_Sync_Img              .Checked  );
      WriteBool   (Name, 'Sync_Attach'           , PDSForm_cb_Sync_Attach           .Checked  );
      WriteBool   (Name, 'ImportGpx'             , PDSForm_cb_ImportGpx             .Checked  );
      WriteBool   (Name, 'ImportGpx_GC'          , PDSForm_rb_ImportGpx_GC          .Checked  );
      WriteBool   (Name, 'ImportGpx_List'        , PDSForm_rb_ImportGpx_List        .Checked  );
      WriteBool   (Name, 'TrackTimeToTrimEnbl'   , TrkDivideForm_cb_TimeToTrimEnbl  .Checked  );
      WriteBool   (Name, 'TrackTrackToTrimEnbl'  , TrkDivideForm_cb_TrackToTrimEnbl .Checked  );
      WriteBool   (Name, 'TrackHdopToTrimEnbl'   , TrkDivideForm_cb_HdopToTrimEnbl  .Checked  );
      WriteFloat  (Name, 'TrackTimeToTrim'       , TrkDivideForm_dt_TimeToTrim      .Time     );
      WriteInteger(Name, 'TrackTrackToTrim'      , StrToInt(TrkDivideForm_ed_DistToTrim.Text) );
      str:=ReplaceString(RegexExtract('\d+(\.|,)\d',TrkDivideForm_ed_HdopToTrim .Text),',','.');
      if str = '' then str:='5.0';
      WriteFloat  (Name, 'TrackHdopToTrim'       , StrToFloat(str)                            );
      WriteBool   (Name, 'Map_geoKuk_Del'        , MapForm_cb_Geokuk_Del            .Checked  );
      WriteBool   (Name, 'Map_ShowInfo'          , MapForm_cb_ShowInfo              .Checked  );
    end;
  finally
    Ini_PD.Free;
    LogWork(_('- profile saved: ') + Name);
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi parametry z okna SetForm}
procedure SaveIniSetForm(Name: String);
var Ini_PD : TIniFile;
begin
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    with Ini_PD do
    begin  
      WriteBool(Name, 'AutoUpdate',        SetForm_cb_AutoUpdate    .Checked);
      WriteBool(Name, 'CmdWriteToFile',    SetForm_cb_CmdWriteToFile.Checked);
      WriteBool(Name, 'Run_PD_NoTest',     SetForm_cb_Run_PD_NoTest .Checked);
      WriteBool(Name, 'Log_Enbl',          SetForm_cb_Log_Enbl      .Checked);
      WriteBool(Name, 'ShowResult_Enbl',   SetForm_cb_ShowResult_Enbl.Checked);
    end;
  finally
    Ini_PD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi parametry z okna TrkForm}
procedure SaveIniTrkForm(Name: String);
var Ini_PD : TIniFile;
    str    : String;
begin
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    with Ini_PD do
    begin  
      WriteBool   (Name, 'TrackTimeToTrimEnbl'   , TrkDivideForm_cb_TimeToTrimEnbl        .Checked  );
      WriteBool   (Name, 'TrackTrackToTrimEnbl'  , TrkDivideForm_cb_TrackToTrimEnbl       .Checked  );
      WriteBool   (Name, 'TrackHdopToTrimEnbl'   , TrkDivideForm_cb_HdopToTrimEnbl        .Checked  );
      WriteFloat  (Name, 'TrackTimeToTrim'       , TrkDivideForm_dt_TimeToTrim            .Time     );
      WriteInteger(Name, 'TrackTrackToTrim'      , StrToInt(TrkDivideForm_ed_DistToTrim   .Text)    );
      str:=ReplaceString(RegexExtract('\d+(\.|,)\d',TrkDivideForm_ed_HdopToTrim .Text),',','.');
      if str = '' then str:='5.0';
      WriteFloat  (Name, 'TrackHdopToTrim'       , StrToFloat(str));
    end;
  finally
    Ini_PD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Ulozi parametry z okna EndForm}
procedure SaveIniEndForm(Name: String);
var Ini_PD : TIniFile;
begin
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    with Ini_PD do
    begin  
      WriteBool   (Name, 'ShowList_ggf'          , EndForm_cb_ShowList_ggf          .Checked  );
      WriteString (Name, 'ShowList_ggfName'      , EndForm_cb_ShowList_ggfName      .Text     );
      WriteBool   (Name, 'ShowList_Orig'         , EndForm_cb_ShowList_Orig         .Checked  );
      WriteBool   (Name, 'ShowList_Upd'          , EndForm_cb_ShowList_Upd          .Checked  );
      WriteBool   (Name, 'ShowList_Imp'          , EndForm_cb_ShowList_Imp          .Checked  );
      WriteBool   (Name, 'ShowList_FN'           , EndForm_cb_ShowList_FN           .Checked  );
    end;
  finally
    Ini_PD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte parametry z okna SetForm}
procedure ReadIniSetForm(Name: String);
var Ini_PD : TIniFile;
begin
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    with Ini_PD do
    begin
      SetForm_cb_AutoUpdate            .Checked   := ReadBool   (Name, 'AutoUpdate'             ,False);
      SetForm_cb_Run_PD_NoTest         .Checked   := ReadBool   (Name, 'Run_PD_NoTest'          ,False);
      SetForm_cb_CmdWriteToFile        .Checked   := ReadBool   (Name, 'CmdWriteToFile'         ,False);
      SetForm_cb_Log_Enbl              .Checked   := ReadBool   (Name, 'Log_Enbl'               ,True);
      SetForm_cb_ShowResult_Enbl       .Checked   := ReadBool   (Name, 'ShowResult_Enbl'        ,True);
    end;
  finally
    Ini_PD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte parametry z okna TrkForm}
procedure ReadIniTrkForm(Name: String);
var Ini_PD : TIniFile;
begin
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    with Ini_PD do
    begin
      TrkDivideForm_cb_TimeToTrimEnbl        .Checked   := ReadBool   (Name, 'TrackTimeToTrimEnbl'    ,False);
      TrkDivideForm_cb_TrackToTrimEnbl       .Checked   := ReadBool   (Name, 'TrackTrackToTrimEnbl'   ,False);
      TrkDivideForm_cb_HdopToTrimEnbl        .Checked   := ReadBool   (Name, 'TrackHdopToTrimEnbl'    ,False);
      TrkDivideForm_dt_TimeToTrim            .Time      := ReadFloat  (Name, 'TrackTimeToTrim'        ,0.041667);  // 1h
      TrkDivideForm_ed_DistToTrim            .Text      := IntToStr   (ReadInteger(Name, 'TrackTrackToTrim' ,10 ));
      TrkDivideForm_ed_HdopToTrim            .Text      := RegexExtract('\d+(\.|,)\d',FloatToStr (ReadFloat  (Name, 'TrackHdopToTrim'  ,5.0)));  
    end;
  finally
    Ini_PD.Free;
  end;
end;

//-------------------------------------------------------------------------------------------------------------------------------
{Nacte parametry z okna EndForm}
procedure ReadIniEndForm(Name: String);
var Ini_PD : TIniFile;
begin
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    with Ini_PD do
    begin
      EndForm_cb_ShowList_ggf          .Checked   := ReadBool   (Name, 'ShowList_ggf'           ,False);
      EndForm_cb_ShowList_ggfName      .Text      := ReadString (Name, 'ShowList_ggfName'       ,'Default');
      EndForm_cb_ShowList_Orig         .Checked   := ReadBool   (Name, 'ShowList_Orig'          ,False);
      EndForm_cb_ShowList_Upd          .Checked   := ReadBool   (Name, 'ShowList_Upd'           ,True);
      EndForm_cb_ShowList_Imp          .Checked   := ReadBool   (Name, 'ShowList_Imp'           ,True);
      EndForm_cb_ShowList_FN           .Checked   := ReadBool   (Name, 'ShowList_FN'            ,True);
    end;
  finally
    Ini_PD.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte profil z ini souboru}
procedure ReadProfile(Name: String);
var Ini_PD : TIniFile;
begin
  Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
  try
    with Ini_PD do
    begin
      if PDSForm_cmb_Profile.Items.Count = 0 then begin
        ReadSection('PROFILES', PDSForm_cmb_Profile.Items);
      end;
      PDSForm_rb_ActiveSync            .Checked   := ReadBool   (Name, 'ActiveSync'             ,True);
      PDSForm_rb_CardReader            .Checked   := ReadBool   (Name, 'CardReader'             ,False);
      PDSForm_rb_Offline               .Checked   := ReadBool   (Name, 'OffLine'                ,False);
      PDSForm_rb_db_GG_Full            .Checked   := ReadBool   (Name, 'db_GG_Full'             ,True);
      PDSForm_rb_db_GG_Filter          .Checked   := ReadBool   (Name, 'db_GG_Filter'           ,False);
      PDSForm_rb_db_PD_Default         .Checked   := ReadBool   (Name, 'db_PD_Default'          ,True);
      PDSForm_rb_db_PD_Custom          .Checked   := ReadBool   (Name, 'db_PD_Custom'           ,False);
      PDSForm_cmb_db_PD_CustomName     .Text      := ReadString (Name, 'ed_PD_CustomName'       ,'cachedb_bak');
      PDSForm_cb_Upd_db_GG             .Checked   := ReadBool   (Name, 'Upd_db_GG'              ,False);
      PDSForm_cb_Gen_FieldNotes_GG     .Checked   := ReadBool   (Name, 'Gen_FieldNotes_GG'      ,False);
      UpdGGForm_cb_Save_db_PD          .Checked   := ReadBool   (Name, 'Save_db_PD'             ,False);
      UpdGGForm_cb_Gen_FieldNotes_PD   .Checked   := ReadBool   (Name, 'Gen_FieldNotes_PD'      ,False);
      UpdGGForm_cb_Gen_FieldNotes_PD_Auto.Checked   := ReadBool   (Name, 'Gen_FieldNotes_PD_Auto' ,False);
      UpdGGForm_cb_Upd_Tracks          .Checked   := ReadBool   (Name, 'Upd_Tracks'             ,False);
      UpdGGForm_cb_Upd_Tracks_Auto     .Checked   := ReadBool   (Name, 'Upd_Tracks_Auto'        ,False);
      UpdGGForm_cb_Upd_Tracks_gpx      .Checked   := ReadBool   (Name, 'Upd_Tracks_gpx'         ,False);
      UpdGGForm_cb_Upd_Tracks_kml      .Checked   := ReadBool   (Name, 'Upd_Tracks_kml'         ,False);
      UpdGGForm_cb_Upd_Tracks_plt      .Checked   := ReadBool   (Name, 'Upd_Tracks_plt'         ,False);
      UpdGGForm_cb_Upd_Tracks_del      .Checked   := ReadBool   (Name, 'Upd_Tracks_del'         ,False);
      UpdGGForm_cb_Del_Tracks          .Checked   := ReadBool   (Name, 'Del_Tracks'             ,False);
      UpdPDForm_cb_PD_Ref_points       .Checked   := ReadBool   (Name, 'PD_Ref_Points'          ,False);
      UpdPDForm_cb_PD_NoteToCmt        .Checked   := ReadBool   (Name, 'PD_NoteToCmt'           ,False);
      PDSForm_cb_Upl_FieldNotes        .Checked   := ReadBool   (Name, 'Upl_FieldNotes'         ,False);
      PDSForm_rb_Upl_FieldNotes_GG     .Checked   := ReadBool   (Name, 'Upl_FieldNotes_GG'      ,True);
      PDSForm_rb_Upl_FieldNotes_PD     .Checked   := ReadBool   (Name, 'Upl_FieldNotes_PD'      ,False);
      PDSForm_cb_Upd_db_PD             .Checked   := ReadBool   (Name, 'Upd_db_PD'              ,False);
      PDSForm_cb_Sync_Img              .Checked   := ReadBool   (Name, 'Sync_Img'               ,False);
      PDSForm_cb_Sync_Attach           .Checked   := ReadBool   (Name, 'Sync_Attach'            ,False);
      PDSForm_cb_ImportGpx             .Checked   := ReadBool   (Name, 'ImportGpx'              ,False);
      PDSForm_rb_ImportGpx_GC          .Checked   := ReadBool   (Name, 'ImportGpx_GC'           ,True);
      PDSForm_rb_ImportGpx_List        .Checked   := ReadBool   (Name, 'ImportGpx_List'         ,False);
      MapForm_cb_Geokuk_Del            .Checked   := ReadBool   (Name, 'Map_Geokuk_Del'         ,False);
      MapForm_cb_ShowInfo              .Checked   := ReadBool   (Name, 'Map_ShowInfo'           ,False);
      if (Name = 'DEFAULT') or (Name = 'FACTORY') then begin
        CardPath                                    := ReadString (Name, 'CardPath'               ,'');
        MobAtlCrPath                                := ReadString (Name, 'LastMobAtlCrPath'       ,'');
        OziMapPath                                  := ReadString (Name, 'LastOziMapPath'         ,'');
        PDSForm_dt_db_LastUpdate         .Date      := ReadInteger(Name, 'db_LastDownload'        ,Trunc(Date));
        PDSForm_dt_FN_LastUpdate_Date    .Date      := Trunc(ReadFloat(Name, 'FN_LastUpdate'      ,Now - 1));
        PDSForm_dt_FN_LastUpdate_Time    .Time      :=       ReadFloat(Name, 'FN_LastUpdate'      ,Now) - PDSForm_dt_FN_LastUpdate_Date.Date;
        PDSForm_ed_ImportGpxID           .Text      := ReadString (Name, 'ImportGpxID'            ,'12345');
        ReadIniSetForm(Name);
        ReadIniEndForm(Name);
      end;
    end;
  finally
    Ini_PD.Free;
    LogWork(_('- profile loaded: ') + Name);
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - Ulozi profil do ini souboru}
procedure form_SaveProfile(Sender: TObject);
begin
  if PDSForm_cmb_Profile.Text = '' then
    ShowMessage(_('Enter a profile name'))
  else begin
    SaveProfile(PDSForm_cmb_Profile.Text);
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - nacteni factory settings}
procedure form_ReadFactoryProfile(Sender: TObject);
begin
    ReadProfile('FACTORY');
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - obsluha vyberu profilu}
procedure form_ProfileChanged(Sender: TObject);
begin
  if (PDSForm_cmb_Profile.ItemIndex <> -1) and (PDSForm_cmb_Profile.Items.Count > 0) then begin
    ReadProfile(PDSForm_cmb_Profile.Text);
    PDSForm_btn_Del.Enabled := true;
  end 
  else
    PDSForm_btn_Del.Enabled := false;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - smaze profil}
procedure form_DelProfile(Sender: TObject);
var
  Ini_PD: TIniFile;
  i : Integer;
begin
  if PDSForm_cmb_Profile.ItemIndex <> -1 then begin
    Ini_PD := TIniFile.Create(MakroPath + 'PocketDrakeSync.ini');
    try
      Ini_PD.EraseSection(PDSForm_cmb_Profile.Text);
      Ini_PD.EraseSection('PROFILES');
      PDSForm_cmb_Profile.Items.Delete(PDSForm_cmb_Profile.ItemIndex);
      for i:= 0 to PDSForm_cmb_Profile.Items.Count - 1 do
        Ini_PD.WriteInteger('PROFILES', PDSForm_cmb_Profile.Items[i], i);
    finally
      Ini_PD.Free;
    end;
    if PDSForm_cmb_Profile.Items.Count > 0 then begin
      PDSForm_cmb_Profile.ItemIndex := 0;
      PDSForm_cmb_Profile.Text := PDSForm_cmb_Profile.Items[0];
      ReadProfile(PDSForm_cmb_Profile.Text)
    end
    else begin
      PDSForm_cmb_Profile.ItemIndex := -1;
      PDSForm_cmb_Profile.Text := '';
    end;
    if PDSForm_cmb_Profile.Items.Count = 0 then PDSForm_btn_Del.Enabled := false;
  end;
end;
//===============================================================================================================================
//-------------------------------------------------------------------------------------------------------------------------------
{Nacte String klic z registru PC - HKEY_CURRENT_USER}
function ReadRegString(RegPath: String; RegKey: String): String;
var reg : TRegistry;
begin
  reg := TRegistry.Create;
  try
    // reg.RootKey:='HKEY_CURRENT_USER';
    if reg.OpenKey(RegPath, False) then
      result := reg.ReadString(RegKey);
  finally
    reg.Free;
  end;
end;
