//-------------------------------------------------------------------------------------------------------------------------------
{Nacteni nastaveni z registru PDA}
procedure ReadRegPDA(All: Boolean; Online: Boolean);
var
  reg       : string;
  Ini_Reg   : TIniFile;
  FormShowed: Boolean;
begin
  // nacteni nastaveni PocketDrake z registru PDA
  FormShowed := PDSForm.Visible and not (TrkForm.Visible or MapForm.Visible);
  if FormShowed then PDSForm.Hide;
  GB_Caption(_('Settings is loading...'));  
  if Online then begin
    GB_Kind(_('reading of register from PDA') + ' - [HKCU\...\PocketDrake\Options]'); 
    RunProc('"' + MakroPath + 'RapiReg.exe" -v "HKEY_CURRENT_USER\Software\PocketDrake\PocketDrake\Options"',        'reg_PDA_Option' , True);
    reg_PDA_CleanUp;   //odstrani soukrome registracni udaje
    GB_Kind(_('reading of register from PDA') + ' - [HKCU\...\PocketDrake\CurrentVersion]');    
    RunProc('"' + MakroPath + 'RapiReg.exe" -v "HKEY_CURRENT_USER\Software\PocketDrake\PocketDrake\CurrentVersion"', 'reg_PDA_CurrVer', True);
    GB_Kind(_('reading of register from PDA') + ' - [HKLM\...\Apps\LudekV PocketDrake]'); 
    RunProc('"' + MakroPath + 'RapiReg.exe" -v "HKEY_LOCAL_MACHINE\software\Apps\LudekV PocketDrake"',         'reg_PDA_Install', True);
    if not FileExists(MakroPath + 'Data\reg_PDA_Option.txt') then begin
      LogWork(_('# Error:') + ' ' + _('File not found:') + ' ' + MakroPath + 'Data\reg_PDA_Option.txt');
      ShowFatalMessage(_('File not found:') + CRLF + MakroPath + 'Data\reg_PDA_Option.txt' + CRLF + CRLF +
                       _('- reading of register from PDA') + _(' failed'));
    end;
    if not FileExists(MakroPath + 'Data\reg_PDA_CurrVer.txt') then begin
      LogWork(_('# Error:') + ' ' + _('File not found:') + ' ' + MakroPath + 'Data\reg_PDA_CurrVer.txt');
      ShowFatalMessage(_('File not found:') + CRLF + MakroPath + 'Data\reg_PDA_CurrVer.txt' + CRLF + CRLF +
                       _('- reading of register from PDA') + _(' failed'));
    end;
    if not FileExists(MakroPath + 'Data\reg_PDA_Install.txt') then begin
      LogWork(_('# Error:') + ' ' + _('File not found:') + ' ' + MakroPath + 'Data\reg_PDA_Install.txt');
      ShowFatalMessage(_('File not found:') + CRLF + MakroPath + 'Data\reg_PDA_Install.txt' + CRLF + CRLF +
                       _('- reading of register from PDA') + _(' failed'));
    end;
    // vytvori z reg souboru format bezneho ini souboru a nacte jednotlive klice
    reg := FileToString(MakroPath + 'Data\reg_PDA_Option.txt') + FileToString(MakroPath + 'Data\reg_PDA_CurrVer.txt') + FileToString(MakroPath + 'Data\reg_PDA_Install.txt')
    reg := ReplaceString(reg, '"', '');
    StringToFile(reg, MakroPath + 'Data\reg_PDA.ini');
  end;
  GB_Kind(_('reading of PDA settings from register file'));
  if not FileExists(MakroPath + 'Data\reg_PDA.ini') then begin
    LogWork(_('# Error:') + ' ' + _('File not found:') + ' ' + MakroPath + 'Data\reg_PDA.ini');
    ShowErrorMessage(_('File not found:') + CRLF + MakroPath + 'Data\reg_PDA.ini' + CRLF + CRLF +
                     _('If you use Off Line mode or External disc mode,')+
                     _('you have to connect device at least once by ActiveSync mode before.') + CRLF + CRLF +
                     _('If you use PDS for the first time, click on YES button.'));
  end
  else begin                     
    Ini_Reg := TIniFile.Create(MakroPath + 'Data\reg_PDA.ini');
    dbFile     := LowerCase(Ini_Reg.ReadString('HKEY_CURRENT_USER\Software\PocketDrake\PocketDrake\Options', 'DbFile', ''));
    dbFile     := ReplaceString(dbFile, '/', '\');    // pro jistotu nahradit opacna lomitka Mudlodcery :-)
    dbName     := RegexExtract('[^\\]+\.db3', dbFile);
    dbPath     := ReplaceString(dbFile, '\' + dbName, '');
    if All then begin
      FNFile     := Ini_Reg.ReadString('HKEY_CURRENT_USER\Software\PocketDrake\PocketDrake\Options', 'FNFile', '');
      FNFile     := ReplaceString(FNFile, '/', '\');    // pro jistotu nahradit opacna lomitka Mudlodcery :-)
      FNName     := RegexExtract('[^\\]+\S$', FNFile);
      FNPath     := ReplaceString(FNFile, '\' + FNName, '');
      FNTemplate := Ini_Reg.ReadString('HKEY_CURRENT_USER\Software\PocketDrake\PocketDrake\Options', 'FNTemplate', '[T] #[N]\x0d\x0a[L]');
      TrackPath  := LowerCase(Ini_Reg.ReadString('HKEY_CURRENT_USER\Software\PocketDrake\PocketDrake\Options', 'TrackFile', ''));
      TrackPath  := ReplaceString(TrackPath, '/', '\'); // pro jistotu nahradit opacna lomitka Mudlodcery :-)
      MapPath    := LowerCase(Ini_Reg.ReadString('HKEY_CURRENT_USER\Software\PocketDrake\PocketDrake\Options', 'MapFolder', ''));
      MapPath    := ReplaceString(MapPath, '/', '\');   // pro jistotu nahradit opacna lomitka Mudlodcery :-)
      PDver      := Ini_Reg.ReadString('HKEY_CURRENT_USER\Software\PocketDrake\PocketDrake\CurrentVersion', 'Version', '?.?.?.?');
      PDLang     := Ini_Reg.ReadString('HKEY_CURRENT_USER\Software\PocketDrake\PocketDrake\Options', 'Language', 'en');
      InstallPath:= LowerCase(Ini_Reg.ReadString('HKEY_LOCAL_MACHINE\software\Apps\LudekV PocketDrake',  'InstallDir', ''));
    end;
    // testuje zda se podarilo nacist nastaveni z registru PDA
    if dbFile = '' then begin 
      LogWork(_('# Error:') + ' ' + _('Location of PocketDrake database failed!'));
      ShowErrorMessage(_('Location of PocketDrake database failed!')+CRLF+
                       _('Check settings of PocketDrake (Settings/General/Database file).')+CRLF+
                       _('Then you have to connect device at least once by ActiveSync mode.'));
    end
    else begin
      if dbName = '' then begin
        LogWork(_('# Error:') + ' ' + _('Name recognition of PocketDrake database failed!'));
        ShowErrorMessage(_('Name recognition of PocketDrake database failed!')+CRLF+
                         _('Check settings of PocketDrake (Settings/General/Database file).')+CRLF+
                         _('Then you have to connect device at least once by ActiveSync mode.'));
      end
      else begin
        if All then begin
          // kontrola verze PocketDrake
          if CompareVer(PDver_Min, PDver) then begin            // pokud verze PD < PDver_Min 
            LogWork(_('# Error:') + ' PocketDrake ' + PDver + _(' - unsupported version! Required min. PocketDrake ') + PDver_Min);
            ShowErrorMessage(_('For proper operation is required PocketDrake version ') + PDver_Min + _(' or higher') +CRLF+ _('Your version: ') + PDver);
          end;
          // kontrola nastaveni
          if (FNFile     = '') and UpdGGForm_cb_Gen_FieldNotes_PD.Checked then begin
            LogWork(_('# Error:') + ' ' + _('Location of FieldNotes failed!'));
            ShowErrorMessage(_('Location of FieldNotes failed!')+CRLF+
                             _('Check settings of PocketDrake (Export FieldNotes/File for export).')+CRLF+
                             _('Then you have to connect device at least once by ActiveSync mode.'));
          end;
          if (FNTemplate = '') and PDSForm_cb_Gen_FieldNotes_GG.Checked then begin 
            LogWork(_('# Error:') + ' ' + _('Reading of FieldNotes template failed!'));
            ShowErrorMessage(_('Reading of FieldNotes template failed!')+CRLF+
                             _('Check settings of PocketDrake (Export FieldNotes/Log template).')+CRLF+
                             _('Then you have to connect device at least once by ActiveSync mode.'));
          end;
          if (TrackPath  = '') and UpdGGForm_cb_Upd_Tracks.Checked then begin 
            LogWork(_('# Error:') + ' ' + _('Location of Tracks failed!'));
            ShowErrorMessage(_('Location of Tracks failed!')+CRLF+
                             _('Check settings of PocketDrake (Export Track/Folder for export).')+CRLF+
                             _('Then you have to connect device at least once by ActiveSync mode.'));
          end;
          if Online then begin
            //zkopiruje map-config.xml                       
            DeleteFiles(MakroPath + 'Data\map-config*.xml');        // odstrani puvodni soubory
            RunProc('"' + MakroPath + 'rapisync.exe" -w "map-config*.xml" -r -d "' + InstallPath + '" "' + MakroPath + 'Data' + '"', 'Sync_MapConfig', True);
          end; 
        end;
      end;
    end;
  end;
  LogWork(_('= Settings loading done.'));
  GB_Clean;
  if FormShowed then PDSForm.Show;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Kontrola pritomnosti PD na SD karte}
function PDCard: Boolean;
begin
  Result := True;
  if PDSForm_rb_CardReader.Checked then begin    
    if not FileExists(ToCardPath(dbFile)) then begin
      Result := False;
      LogWork(_('# Selected PocketDrake external disc not contains database: ') + ToCardPath(dbFile));
      ShowMessage(_('File not found on selected disc:') + CRLF + ToCardPath(dbFile) + CRLF + CRLF +
                  _('Probably it is not the PocketDrake data disc.'));
    end;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Podpora pripojeni pres externi disk}
procedure form_CardPath(Sender: TObject);
var
  script : String;
begin
  script := SelectDir(CardPath, _('Select disc where Pocketdrake is installed.')+CRLF+_('example: E:\'));
  if script <> '' then begin
    CardPath := RegexExtract('^\w:\\', script);     //vykousne pouze pismeno disku s ":\"
    PDSForm_ed_PD_disc.Text  := CardPath;
    MapForm_ed_PD_disc.Text  := CardPath;
    SaveIniStrValue('DEFAULT', 'CardPath', CardPath);  
    LogWork(_('- PocketDrake external disc selected: ') + CardPath);
    PDCard;  //kontrola nastaveni disku s PD
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{zjisteni cesty k mapovym kachlim programu GeoKuk}
function SmartPath_GK(path: String): String;
begin
  Result := ReadRegString('\Software\JavaSoft\Prefs\geokuk\current\umisteni/Souboru', 'kachle/Cache/Dir');
  StringToFile(result, Makropath + 'Data\reg_GeoKuk.txt'); // pro testovaci ucely
  Result := RegexReplace('/{2,5}', Result, '\', False);                         // nahradi '//|///|...' z retezce registru znakem '\' (co se to tam do toho registru uklada za nesmysly!!??)
  Result := ReplaceString(Result, '/', '');                                     // odmazne zbyla samostatna '/' z retezce, pokud tam jsou (se tam nejak zbytecne nacpaly na divny mista)
  Result := ReplaceString(path, '<auto>', Result);
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - zjisteni databazi v PDA}
procedure form_dbSeek(Sender: TObject);
var 
  script : string;
begin
  if not PDSForm_rb_Offline.Checked then begin
    ReadRegPDA(False, PDSForm_rb_ActiveSync.Checked);  // nacte si nastaveni z registru PDA
    if PDCard then begin     // otestuje umisteni PD na externim disku
      if PDSForm_rb_CardReader.Checked then script := 'dir "' + ToCardPath(dbPath) + '\*.db3" /B'
                                       else script := '"' + MakroPath + 'rapitree.exe" -dd- -n -r -c -w "*.db3" "' + dbPath + '"';
      RunProc(script, 'dbList_PDA', True);
      if FileExists(MakroPath + 'Data\dbList_PDA.txt') then begin
        script := LowerCase(FileToString(MakroPath + 'Data\dbList_PDA.txt'));
        if (script = '') OR (pos('WARNING', script) <> 0) then ShowMessage(_('Reading of database list failed.')+CRLF+CRLF+_('Error code:') +CRLF+ script)
        else begin
          script := RegexExtract('[^\s]+\.db3', script);
          PDSForm_cmb_db_PD_CustomName.Items.Clear;
          while trim(script) <> '' do begin
            PDSForm_cmb_db_PD_CustomName.Items.Add(SeparateLeft(FetchBin(script, CRLF), '.db3'));
          end;
          PDSForm_cmb_db_PD_CustomName.ItemIndex := PDSForm_cmb_db_PD_CustomName.Items.Count - 1;
        end;
      end
      else ShowMessage(_('Error: Creating of database list failed.'));
    end;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Priprava pracovni databaze GeoGetu -  v pripade ze se pracuje pouze s vyfiltrovanym seznamem}
procedure dbWorkListCreate();
begin
  if PDSForm_rb_db_GG_Filter.Checked then begin
    GB_Caption(_('Temporary GeoGet database is prepared'));   
    // export zmen do gpx souboru
    GB_Kind(_('the filtered cache list is exported...'));
    StringToFile('GC0', MakroPath + 'Data\GC0.ggt');  //pro doplneni GC0 (Add-hoc WP) do seznamu
    GeoListFileAdd(MakroPath + 'Data\GC0.ggt');
    DeleteFile(MakroPath + 'Data\GeoGetFilter_db.gpx');
    GeoExport(GEOGET_SCRIPTDIR + '\export\gpxgeoget2.gge.pas', MakroPath + 'Data\GeoGetFilter_db.gpx');
    if not FileExists(MakroPath + 'Data\GeoGetFilter_db.gpx') then begin
      LogWork('# ' +   _('Error: File "') + MakroPath + 'Data\GeoGetFilter_db.gpx' + _('" not found!'));
      ShowErrorMessage(_('Error: File "') + MakroPath + 'Data\GeoGetFilter_db.gpx' + _('" not found!') + CRLF 
                     + _('Check export macro: ') + CRLF + GEOGET_SCRIPTDIR + '\export\gpxgeoget2.gge.pas');
    end;
    // vytvori pracovni databazi
    GeoDBSelect('$PocketDrake_Work$');                    // zalozi pracovni databazi
    GB_Kind(_('the list is imported to a work database...'));
    GeoImportFile(MakroPath + 'Data\GeoGetFilter_db.gpx');
    GeoDBSelect(PDSForm_lbl_db_GG_Name.Caption);          // prepne na aktivni databazi
    GB_Clean;
  end
  else CopyFile(GEOGET_DATADIR + '\' + GEOGET_DBNAME + '.db3', GEOGET_DATADIR + '\' + '$PocketDrake_Work$.db3');
  LogWork(_('- Temporary GG database created: $PocketDrake_Work$'));
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Naplni StringList soubory z daneho adresare vcetne podadresaru}
procedure FileAllList(Dir, RegexMaskPath, RegexMaskFile: string; List: TStringList);
var
  Files,Queue  : TStringList;
  n : Integer;
begin
  if DirectoryExists(Dir) then begin
    Queue    := TStringList.Create;
    Files    := TStringList.Create;
    try
      Queue.Add(Dir);
      while (Queue.Count > 0) do begin
        if GB_Test then Break;  //preruseno uzivatelem
        GB_Progress(1, Trunc(sqrt(List.Count)) ,Trunc(sqrt(List.Count))+1);
        FileList(Queue[0],Files); Queue.Delete(0);
        for n := 0 to Files.Count-1 do begin
          if RegexFind('\\$',Files[n]) then begin if RegexFind(RegexMaskPath,Files[n]) then Queue.Add(Files[n]); end
                                       else begin if RegexFind(RegexMaskFile,Files[n]) then List.Add(Files[n]);  end;
        end;
      end;
      GB_Progress(1, 0 ,100);
    finally;
      Queue.Free; Files.Free;
    end;
  end;
end;  
//===============================================================================================================================
//-------------------------------------------------------------------------------------------------------------------------------
{Kopiruje obsah adresare PC<->PC vcetne podslozek, pouze soubory dle zadane regex masky}
procedure SmartCopyPC(FromDir: string; ToDir: string; RegexMaskFile: string; Caption: string);
var
  Files        : TStringList;
  NameDestFile : string;
  n : Integer;
begin
  if not RegexFind('\\$',FromDir) then FromDir := FromDir + '\';
  if not RegexFind('\\$',ToDir)   then ToDir   := ToDir   + '\';
  if DirectoryExists(FromDir) then begin
    GB_Caption(Caption);
    Files    := TStringList.Create;
    try
      GB_Kind(_('files are calculated:') + RegexExtract('[^\\]+\S$',FromDir) + RegexMaskFile);
      GB_Value(FromDir + RegexMaskFile);
      FileAllList(FromDir, '.*', RegexMaskFile, Files);   //naplni seznam vsech souboru z adresare a jeho podadresaru
      GB_Kind(_('files are copied: ') + RegexExtract('[^\\]+\S$',FromDir) + RegexMaskFile);
      for n := 0 to Files.Count-1 do begin
        GB_Progress(1, n ,Files.Count);
        NameDestFile   := ToDir + ReplaceString(Files[n], FromDir, '');
        MakeDirPC(ReplaceString(NameDestFile, RegexExtract('[^\\]+\S$',NameDestFile), ''));
        CopyFile(Files[n], NameDestFile);
        if GB_Test then Break;  //preruseno uzivatelem
      end;
      LogWork(' .. SmartCopyPC: ' + Caption);
    finally
      Files.Free;
    end;
    GB_Clean;
  end;
end;
